C***********************************************************************
C $Id: arptqq.f,v 3.14 2001/11/23 12:02:25 leif Exp $

      SUBROUTINE ARPTQQ(KF,KQ,PM,PT2MAX,PT2MIN,X,XQ2,XY,XP,ZQ,YQ,PHI)

C...ARiadne get PT2 of initial state g->QQ

C...Get kinematical variables describing an initial-state g->qqbar
C...splitting.


      INCLUDE 'arimpl.f'
      INCLUDE 'ardat1.f'
      INCLUDE 'arhide.f'
      INCLUDE 'pydat1.f'
      INCLUDE 'ardble.f'


      XP=X
      ZQ=1.0D0
      IF (MHAR(104).GT.1.AND.XY.GE.1.0D0) THEN
        CALL ARMTQQ(KF,KQ,PM,PT2MAX,PT2MIN,X,XQ2,YQ,PHI)
        RETURN
      ENDIF

      PHI=0
      T2=(1.0D0-X)*XQ2
      IF (MHAR(102).EQ.2) T2=XQ2
      PT2MAX=MIN(PT2MAX,0.25D0*T2/X)
      IF (MHAR(102).EQ.2) PT2MAX=MIN(PT2MAX,0.25D0*(1.0D0-X)*T2/X)
      IF (MHAR(102).LT.0) GOTO 900
      RMQ=PYMASS(KQ)
      PT2CUT=PT2MIN
      IF (MHAR(102).GE.1) PT2CUT=MAX(PT2MIN,DBLE(PARA(3))**2+RMQ**2)
      IF (PT2MAX.LE.PT2CUT) GOTO 900

      XNUMFL=MAX(ARNOFL(SQRT(T2/X),MAX(5,MSTA(15))),3.0D0)
      ALPHA0=12.0D0*ARX2DB(PARU(1))/(33.0D0-2.0D0*XNUMFL)
      SQ2MIN=DBLE(PHAR(103))*PT2CUT/DBLE(PARA(21))
      IF (MHAR(151).EQ.1) SQ2MIN=MAX(SQ2MIN,XQ2)
      SQ2MIN=MAX(SQ2MIN,4.0D0*RMQ**2)
      STRA0=ARSTRA(KF,KQ,X,1.0D0,SQ2MIN)
      STRAQ=ARSTRA(KF,KQ,X,1.0D0,XQ2)
      IF (MHAR(113).EQ.-2.AND.MHAR(102).EQ.2) THEN
        XPMAX=T2*0.25D0/(PT2CUT+T2*0.25D0)
        STRAQ=ARSTRA(KF,KQ,X,XPMAX,XQ2)
      ENDIF
      IF (STRA0.LE.0.0D0) STRA0=STRAQ
      IF (MHAR(113).NE.1) STRA0=STRAQ
      IF (MHAR(151).NE.1) STRA0=MAX(STRAQ,STRA0)

      IF (MHAR(109).GT.0) THEN
        SQ2MIN=PT2CUT/
     $       ((0.5D0+SQRT(MAX(0.25D0-PT2CUT*X/(XQ2*(1.0D0-X)), 
     & 0.0D0)))*(1.0D0-X))
        SQ2MAX=0.5D0*(XQ2+PT2MAX)
        STRA0=STRAQ
        STRA0=MAX(STRA0,ARSTRA(KF,KQ,X,1.0D0,SQ2MIN))
        STRA0=MAX(STRA0,ARSTRA(KF,KQ,X,1.0D0,SQ2MAX))
      ENDIF

      CY=(1.0D0-XY)/(1.0D0+(1.0D0-XY)**2)
      CQ=1.0D0+CY
      IF (MHAR(102).EQ.2) CQ=0.125D0+0.25D0*CY
      C=DBLE(PHAR(104))*0.25D0*ALPHA0*STRA0*CQ/ARX2DB(PARU(1))
      THEMAX=PT2MAX
      YINT=4.0D0*LOG(SQRT(THEMAX/PT2CUT)+SQRT(THEMAX/PT2CUT-1.0D0))
      CN=1.0D0/(YINT*C)
      IF (MHAR(110).GT.0) CN=1.0D0/(YINT*C*ALPHA0)
      XLAM2=DBLE((PARA(1)**2)/PHAR(103))

 100  IF (PT2MAX.LE.PT2CUT) GOTO 900
      ARG=PYR(IDUM)
      IF (LOG(ARG)*CN.LT.
     $     LOG(LOG(PT2CUT/XLAM2)/LOG(PT2MAX/XLAM2))) GOTO 900
      PT2MAX=XLAM2*(PT2MAX/XLAM2)**(ARG**CN)

      YMAX=2.0D0*LOG(SQRT(THEMAX/PT2MAX)+SQRT(THEMAX/PT2MAX-1.0D0))
      Y=(PYR(IDUM)*2.0D0-1.0D0)*YMAX

      ZQ=1.0D0/(1.0D0+EXP(-Y))
      IF (MHAR(112).LT.0.OR.MHAR(112).EQ.2) ZQ=MIN(ZQ,1.0D0-ZQ)
      IF (MHAR(102).EQ.2) THEN
        XP=T2*ZQ*(1.0D0-ZQ)/(PT2MAX+T2*ZQ*(1.0D0-ZQ))
      ELSE
        XP=ZQ*(1.0D0-ZQ)*T2/PT2MAX
      ENDIF
      IF (XP.LE.X.OR.XP.GE.1.0D0) GOTO 100

      SQ2=DBLE(PHAR(103))*PT2MAX/DBLE(PARA(21))

      W=2.0D0*YMAX/YINT
      IF (MHAR(151).EQ.1) THEN
        W=W*MIN(1.0D0,LOG(PT2MAX/XLAM2)/LOG(DBLE(PARA(21))*XQ2/XLAM2))
        SQ2=MAX(SQ2,XQ2)
      ENDIF
      SQ2=MAX(SQ2,SQ2MIN)
      IF (MHAR(109).GT.0) SQ2=PT2MAX/
     $     ((0.5D0+SQRT(MAX(0.25D0-PT2MAX*XP/(XQ2*(1.0D0-XP)),0.0D0)))*
     $     (1.0D0-XP))
      IF (MHAR(113).EQ.1) THEN
        STRA=ARSTRA(KF,KQ,X,XP,SQ2)
        W=W*STRA/STRA0
      ELSE
        BETA=DBLE(PARA(25))
        IF (MSTA(25).EQ.0) BETA=0.0D0
        PTIN=SQRT(DBLE(PHAR(103))*PT2MAX)
        IF (MHAR(113).EQ.2) PTIN=2.0D0*PTIN
        XMU=DBLE(PARA(11))
        ALPHA=DBLE(PARA(10))
        IF (PARA(10).GT.0.0) THEN
          XMU=DBLE(PARA(11))
          ALPHA=DBLE(PARA(10))
        ELSEIF (PTIN.GE.DBLE(ABS(PARA(10)))) THEN
          XMU=DBLE(SQRT(ABS(PARA(10)*PARA(11))))
          ALPHA=2.0D0
        ELSE
          XMU=DBLE(PARA(11))
          ALPHA=1.0D0
        ENDIF
        IF (X/XP.GT.((1.0D0/PYR(IDUM)-1.0D0)**BETA)*(XMU/PTIN)**ALPHA)
     $       GOTO 100
      ENDIF
      IF (MHAR(102).EQ.2) THEN
        W=W*(XP*(1.0D0-XP)*(XP**2+(1.0D0-XP)**2)*(ZQ**2+(1.0D0-ZQ)**2)+
     $       16.0D0*((XP*(1.0D0-XP))**2)*ZQ*(1.0D0-ZQ)*CY)/CQ
      ELSE
        W=W*((XP**2+(1.0D0-XP)**2)*(ZQ**2+(1.0D0-ZQ)**2)+
     $       16.0D0*XP*(1.0D0-XP)*ZQ*(1.0D0-ZQ)*CY)/CQ
      ENDIF

      IF (W.GT.1.0D0) THEN
        CALL ARERRM('ARPTQQ',22,0)
        RETURN
      ENDIF

      IF (W.LT.PYR(IDUM)) GOTO 100

      IF (MHAR(113).EQ.-1) THEN
        IF (PT2MAX.LT.ZQ*(1.0D0-X)*XQ2) GOTO 100
        IF (PT2MAX.LT.(1.0D0-ZQ)*(1.0D0-X)*XQ2) GOTO 100
      ENDIF

      YQ=0.5D0*LOG(ZQ*(1.0D0-X)/((1.0D0-ZQ)*(X/XP-X)))

      XA=0.125D0*(1.0D0+(1.0D0-XY)**2)*(XP**2+(1.0D0-XP)**2)*
     $     (ZQ**2+(1.0D0-ZQ)**2)/(ZQ*(1.0D0-ZQ)) 
     & +2.0D0*(1.0D0-XY)*XP*(1.0D0-XP)
      XB=0.5D0*XY*SQRT((1.0D0-XY)*XP*(1.0D0-XP)/(ZQ*(1.0D0-ZQ)))*(1.0D0 
     & -2.0D0/XY)*
     $     (1.0D0-2.0D0*ZQ)*(1.0D0-2.0D0*XP)
      XC=(1.0D0-XY)*XP*(1.0D0-XP)

      ABC=ABS(XA)+ABS(XB)+ABS(XC)
 200  PHI=ARX2DB(PARU(2))*PYR(IDUM)
      IF (XA+XB*COS(PHI)+XC*COS(2.0D0*PHI).LT.PYR(IDUM)*ABC) GOTO 200

      RETURN

 900  PT2MAX=0.0D0
      RETURN

C**** END OF ARPTQQ ****************************************************
      END
